local context = UI.CreateContext("Context")
local frame = UI.CreateFrame("Text", "SpellSpamFrame", context)
frame:SetPoint("TOPCENTER", UIParent, "TOPCENTER")
frame:SetBackgroundColor(0, 0, 0, 1)
frame:SetWidth(200)
frame:SetHeight(50)
frame:SetFontSize(22)
frame:SetFontColor(71,71,71)
local Buffs={}
local self = {}
local target = {}
local Abilities = {}
SpellSpam={}
SpellSpam.LastCast = nil
local LastCastFunction = nil
SpellSpam.SelfBuffs = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Self Buffs".. i.."SpellName-".. SpellSpamDataRole]
		if not Abilities[ability] then return false end
		if SpellSpam.CanBuff("player", ability) and not self.combat then
			SpellSpam.CastSpell(ability,SpellSpamData["Self Buffs".. i.."KeySlot-".. SpellSpamDataRole],"SelfBuffs")
			return true
		end
	end
	return false
end
SpellSpam.Boosters = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Boosters".. i.."SpellName-".. SpellSpamDataRole]
		if not Abilities[ability] then return false end
		if SpellSpam.CanBuff("player", ability) then
			SpellSpam.CastSpell(ability,SpellSpamData["Boosters".. i.."KeySlot-".. SpellSpamDataRole],"Boosters")
			return true
		end
	end
	return false
end

SpellSpam.Openers = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Opener".. i.."SpellName-".. SpellSpamDataRole]
		if not Abilities[ability] then return false end
		
		if self.combat and Abilities[ability].castingTime then -- if the spell is instant let it be cast
			if SpellSpam.CancelSpell(ability,"Openers") then
				debugtext(ability .. " we are in combat")
				return true
			end
			return false
		elseif SpellSpam.CanBuff("player", ability) then
				SpellSpam.CastSpell(ability,SpellSpamData["Opener".. i.."KeySlot-".. SpellSpamDataRole],"Openers")
				return true
		end
	end
	return false
end
SpellSpam.CancelSpell = function(ability, functionname)
	if not (LastCastFunction == functionname) then return false end -- dont cancel. only the function that cast the spell are allowed to cancel it
	if not self.castbar then return false end -- no castbar = nothing to cancel
	if not self.castbar.abilityName then return false end -- no name to compare with.
	if not self.castbar.abilityName == ability then return false end -- the castbars name does not match
	SpellSpam.CastSpell("Cancel " .. ability, 101, functionname)
	return true
end
SpellSpam.CastwhenInstant = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Cast when Instant".. i.."SpellName-".. SpellSpamDataRole]
		if not Abilities[ability] then return false end
		if Abilities[ability].castingTime then	
			if SpellSpam.CancelSpell(ability,"CastwhenInstant") then
				debugtext(ability .. " is not instant anymore!")
				return true
			end
		end
		if Abilities[ability].castingTime then return false end -- spell is not instant
		if SpellSpam.CanBuff("player",ability) then
			if self.castbar then
				if not self.castbar.abilityName == ability then
					if SpellSpam.CancelSpell(self.castbar.abilityName,"CastwhenInstant") then
						debugtext(ability .. " is instant!")
						return true
					end
				end
			end
			SpellSpam.CastSpell(ability,SpellSpamData["Cast when Instant".. i.."KeySlot-".. SpellSpamDataRole],"CastwhenInstant")
			return true
		end
	end
	return false
end

SpellSpam.TargetBuffs = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Target Buffs".. i.."SpellName-".. SpellSpamDataRole]
		if not Abilities[ability] then return false end
		if SpellSpam.CanBuff("player.target", ability) then
			SpellSpam.CastSpell(ability,SpellSpamData["Target Buffs".. i.."KeySlot-".. SpellSpamDataRole],"TargetBuffs")
			return true
		end
	end
	return false
end

SpellSpam.SelfHeal = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Self Heal".. i.."SpellName-".. SpellSpamDataRole]
		if self.castbar then
			if self.castbar.abilityName == ability and self.health < self.healthMax and self.combat == nil  then
				--debugtext("SelfHeal " .. ability .." is casting my health under 100% and im not in combat. Dont cast anything else")
				return true
			end
		end
		if not Abilities[ability] then return false end
		if self.health < self.healthMax * 0.60 and self.combat == nil and SpellSpam.CanCast(ability) then
			SpellSpam.CastSpell(ability,SpellSpamData["Self Heal".. i.."KeySlot-".. SpellSpamDataRole],"SelfHeal")
			return true
		end
	end
	return false
end
SpellSpam.FindTarget = function()
	if target == nil or target.health == 0 then
		SpellSpam.CastSpell("New Target",100)
		return true
	end
	return false
end
SpellSpam.AbilitySequence = function()
	for i = 1,6,1 do
		local ability = SpellSpamData["Ability sequence".. i.."SpellName-".. SpellSpamDataRole]
		if not Abilities[ability] then return false end
		if SpellSpam.CanCast(ability) then
			SpellSpam.CastSpell(ability,SpellSpamData["Ability sequence".. i.."KeySlot-".. SpellSpamDataRole],"AbilitySequence")
			return true
		end
	end
	return false
end
function RefreshSpellButton()
	SpellSpam.RefreshAbilitesList()
	SpellSpam.RefreshBuffList("player.target")
	SpellSpam.RefreshBuffList("player")
	SpellSpam.RefreshStats("player")
	SpellSpam.RefreshStats("player.target")
    if not self then return false end
	
	if SpellSpam.SelfHeal() then return end
	
	if SpellSpam.SelfBuffs() then return end
	if SpellSpam.FindTarget() then return end
	if SpellSpam.Openers() then return end
	if SpellSpam.TargetBuffs() then return end
	if SpellSpam.Boosters() then return end
	if SpellSpam.CastwhenInstant() then return end
	if SpellSpam.AbilitySequence() then return end
	
	SpellSpam.CastSpell(SpellSpamData["Ability sequence1SpellName-".. SpellSpamDataRole],SpellSpamData["Ability sequence1KeySlot-".. SpellSpamDataRole],"AbilitySequence")
end
SpellSpam.RefreshStats = function(unit)
	local info = Inspect.Unit.Detail(unit)
	if not info then
		if unit == "player" then
			self = nil
		elseif unit == "player.target" then
			target = nil
		end
		return
	end
	if not info.mana then info.mana = 0 end
	if not info.charge then info.charge = 0 end
	if not info.power then info.power = 0 end
	if not info.energy then info.energy = 0 end
	if not info.planarCharge then info.planarCharge = 0 end
	local castbar = Inspect.Unit.Castbar(unit)
	
	if castbar then info.castbar = castbar else info.castbar = nil end
	
	if unit == "player" then
		self = info
	elseif unit == "player.target" then
		target = info
	end
	
end
SpellSpam.RefreshBuffList = function(unit)
	   local list = Inspect.Buff.List(unit)
	   Buffs[unit] = {}
       -- Get the current list of buffs --
	   if not list then return end
	   local details = Inspect.Buff.Detail(unit, list)
       -- Step through the table --
       for id, buff in pairs(details) do
			Buffs[unit][buff.name] = buff
       end
end		
SpellSpam.RefreshAbilitesList = function()
	   Abilities = {}
       -- Get the current list of abilities --
       local list = Inspect.Ability.List()
	   if not list then return end
       -- Step through the table --
	   local details = Inspect.Ability.Detail(list)
       for id, ability in pairs(details) do
			Abilities[ability.name] = ability
       end
end

SpellSpam.CastSpell = function(spellname,keyslot,functionname)
	LastCastFunction = functionname
	if not (SpellSpam.LastCast == spellname) then
		debugtext(spellname)
		
		if keyslot then
			frame:SetBackgroundColor(keyslot / 255, 0, 0, 1)
		else
			print("No keyslot set for ".. spellname)
			frame:SetBackgroundColor(255, 255, 0, 1)
		end
		frame:SetText("    "..spellname)
		SpellSpam.LastCast = spellname
	end
end
SpellSpam.EnsureBuff = function(unit, list)
    for id, ability in pairs(list) do
		if SpellSpam.CanBuff(unit, ability) then
			-- cast ability
		SpellSpam.CastSpell(ability)
			return true
		end
    end
	return false
end
SpellSpam.CanCast = function(spellname)
	local ability = Abilities[spellname]
	if (not ability) or ability.unusable or ability.outOfRange then
		return false
	end
	if ability.currentCooldownRemaining and ability.currentCooldownRemaining > 1.5 then
		return false
	end
	if not ability.costMana then ability.costMana = 0 end
	if not ability.costCharge then ability.costCharge = 0 end
	if not ability.costPower then ability.costPower = 0 end
	if not ability.costEnergy then ability.costEnergy = 0 end
	if not ability.costPlanarCharge then ability.costPlanarCharge = 0 end

	if ability.costMana > self.mana then return false end
	if ability.costCharge > self.charge then return false end
	if ability.costPower > self.power then return false end
	if ability.costEnergy > self.energy then return false end
	if ability.costPlanarCharge > self.planarCharge then return false end
	
	return true
end

SpellSpam.CanBuff = function(unit,spellname)
	if SpellSpam.HasBuff(unit,spellname) then return false end
	return SpellSpam.CanCast(spellname)
end
SpellSpam.HasBuff = function(unit,spellname)
	
	if not Buffs[unit] then
		return false
	end
	if Buffs[unit][spellname] == nil then
		return false
	else
		return true
	end
	return not Buffs[unit][spellname] == nil
end
local function DumpAbility(spellname)
	debugtext(dump(Abilities[spellname]))
end
local function dump(o)
	if type(o) == 'table' then
		local s = '{ '
		for k,v in pairs(o) do
			if type(k) ~= 'number' then k = '"'..k..'"' end
			s = s .. '['..k..'] = ' .. dump(v) .. ',\n'
		end
		return s .. '} '
	else
		return tostring(o)
	end
end
function debugtext(text)
	--print(text)
end
-- table.insert(Event.System.Update.Begin, {refresh, "SpellSpam", "refresh"})
local name = Inspect.Addon.Detail(Inspect.Addon.Current()).name
print(name .. " loaded");