local SpellSpamMap = {}
local name = Inspect.Addon.Detail(Inspect.Addon.Current()).name
local context
local SpellSpamMapWindow
local textboxcollection
local role = "0"
-- Addon Init
local function init()
	context = UI.CreateContext("SpellSpamMapContext")
	textboxcollection = {}
	----------------
	-- Main Frame --
	SpellSpamMapWindow = UI.CreateFrame("RiftWindow", "SpellSpamMap", context)
	SpellSpamMapWindow:SetVisible(false)
	--SpellSpamMapWindow:SetPoint("TOPCENTER", UIParent, "TOPCENTER",0,100)
	SpellSpamMapWindow:SetWidth(750)
	SpellSpamMapWindow:SetHeight(850)
	SpellSpamMapWindow:SetTitle(name)
	----------------
	SpellSpamMapWindow.Lines = {}
	SpellSpamMapWindow.LinesY = 100
	SpellSpamMapWindow.AddText = function(text,x,y)
		local scaleText = UI.CreateFrame("Text", "SpellSpamMapText"..tostring(x)..tostring(y), SpellSpamMapWindow)
		scaleText:SetPoint("TOPLEFT", SpellSpamMapWindow, "TOPLEFT", x, y)
		scaleText:SetFontSize(15)
		scaleText:SetFontColor(71,71,71)
		scaleText:SetText(text)
		return scaleText
	end
	SpellSpamMapWindow.AddBox = function(x,y,label,width)
		local scaleText = UI.CreateFrame("RiftTextfield", label, SpellSpamMapWindow)
		scaleText:SetPoint("TOPLEFT", SpellSpamMapWindow, "TOPLEFT", x, y)
		scaleText:SetBackgroundColor(0,0,0,1)
		scaleText:SetWidth(width)
		return scaleText
	end

	SpellSpamMapWindow.AddLine = function(label,description)
		SpellSpamMapWindow.AddText(label .. " (".. description .. ")",130, SpellSpamMapWindow.LinesY-30)
		SpellSpamMapWindow.AddText("Ability",30, SpellSpamMapWindow.LinesY)
		SpellSpamMapWindow.AddText("Key slot",30, SpellSpamMapWindow.LinesY+30)
		local x = 0
		for i =  130, 700, 100 do
			x = x + 1
			local spellname = SpellSpamMapWindow.AddBox(i, SpellSpamMapWindow.LinesY, label ..tostring(x).."SpellName",90)
			local keyslot = SpellSpamMapWindow.AddBox(i, SpellSpamMapWindow.LinesY + 30, label ..tostring(x).."KeySlot",20)
			textboxcollection[label .. tostring(x) .. "SpellName"] = spellname
			textboxcollection[label .. tostring(x) .. "KeySlot"] = keyslot
			function spellname.Event:LeftUp()
				local t, held = Inspect.Cursor()
				if t == "ability" then
					local ability = Inspect.Ability.Detail(held)
					if ability and ability.name then 
						spellname:SetText(ability.name)
					end
				end
			end
		end
		-- local box = SpellSpamMapWindow.AddBox(150, SpellSpamMapWindow.LinesY, label)
		SpellSpamMapWindow.LinesY = SpellSpamMapWindow.LinesY + 100
	end
	SpellSpamMapWindow.AddLine("Self Buffs", "Casts when out of combat.")
	SpellSpamMapWindow.AddLine("Self Heal", "Casts when health below 60% and out of combat.")
	SpellSpamMapWindow.AddLine("Opener", "Spells to cast when out of combat and you have a target.")
	SpellSpamMapWindow.AddLine("Boosters", "Buffs to cast when you have a target. ")
	SpellSpamMapWindow.AddLine("Target Buffs", "Casts spells so they have these buffs.")
	SpellSpamMapWindow.AddLine("Cast when Instant","When spell is instant.")
	SpellSpamMapWindow.AddLine("Ability sequence","Cast these as default spells.")

	local rolelabel = SpellSpamMapWindow.AddText("Your soul role is not loaded",30,800)
	
	----------------
	-- Scale Slider --
	local scaleSlider = UI.CreateFrame("RiftSlider", "SpellSpamMapSlider", SpellSpamMapWindow)
	scaleSlider:SetPoint("BOTTOMLEFT", SpellSpamMapWindow, "BOTTOMLEFT", 200, -20)
	scaleSlider:SetRange(0, 10)
	scaleSlider:SetWidth(350)
	function scaleSlider.Event:SliderChange()
		local role = scaleSlider:GetPosition()
		SpellSpamMapWindow.SetRole(role)
	end
	----------------
	
	----------------
	--  Movement  --
	SpellSpamMaplock = UI.CreateFrame("Frame", "Lock", SpellSpamMapWindow)
	SpellSpamMaplock:SetWidth(790)
	SpellSpamMaplock:SetHeight(50)
	SpellSpamMaplock:SetBackgroundColor(0.75,0.75,0.75,.01)
	SpellSpamMaplock:SetPoint("TOPLEFT", SpellSpamMapWindow, "TOPLEFT", 5,5)
	SpellSpamMaplock:SetVisible(true)

	function SpellSpamMaplock.Event:LeftDown()
		self.MouseDown = true
		mouseData = Inspect.Mouse()
		self.sx = mouseData.x - SpellSpamMapWindow:GetLeft()
		self.sy = mouseData.y - SpellSpamMapWindow:GetTop()
	end

	function SpellSpamMaplock.Event:MouseMove()
		if self.MouseDown then
			local nx, ny
			mouseData = Inspect.Mouse()
			nx = mouseData.x - self.sx
			ny = mouseData.y - self.sy
			SpellSpamMapWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
		end
	end

	function SpellSpamMaplock.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
	end
	----------------

	
	
	----------------
	-- Close Btn  --
	local closeButton = UI.CreateFrame("RiftButton", "SpellSpamMapCloseButton", SpellSpamMapWindow)
	closeButton:SetText("Close")
	closeButton:SetPoint("BOTTOMRIGHT", SpellSpamMapWindow, "BOTTOMRIGHT", -20, -20)

	function closeButton.Event:LeftPress()
		SpellSpamMapWindow:SetVisible(false)
		SpellSpamMapWindow.SaveRole(SpellSpamDataRole)
	end
	----------------
	
	
	SpellSpamMapWindow.SaveRole = function(role)
		if not SpellSpamData then SpellSpamData = {} end
		for i, textbox in pairs(textboxcollection) do
			SpellSpamData[i.."-".. role] = textbox:GetText()
		end
	end
	SpellSpamMapWindow.LoadRole = function(role)
		for i, textbox in pairs(textboxcollection) do
			if SpellSpamData[i .. "-" .. role] then
				textbox:SetText(SpellSpamData[i .. "-" .. role])
			else
				textbox:SetText("")
			end	
		end
		SpellSpamDataRole = role
		rolelabel:SetText("Your soul role is  ".. role)
		scaleSlider:SetPosition(role)
	end
	-- set Role
	-- SpellSpamMapWindow.SetRole(2)
	SpellSpamMapWindow.SetRole = function(role)
		SpellSpamMapWindow.SaveRole(SpellSpamDataRole)
		SpellSpamMapWindow.LoadRole(role)
	end
end
-- display
local function showSpellSpamMap()
	SpellSpamMapWindow:SetVisible(true)
end

-- initialisation
	init()
local function SpellSpamLoad(addon)
   if addon == "SpellSpam" then
		if not SpellSpamData then SpellSpamData = {} end
		if not SpellSpamDataRole then SpellSpamDataRole = 1 end
		-- Register the slash commands
		table.insert(Command.Slash.Register("showSpellSpamMap"), {showSpellSpamMap, "SpellSpam", "Slash command"})
		SpellSpamMapWindow.LoadRole(SpellSpamDataRole)
		print("Type /showSpellSpamMap to show the Ability Map")
   end
end
local function SpellSpamSave(addon)
	if addon == "SpellSpam" then
		SpellSpamMapWindow.SaveRole(SpellSpamDataRole)
   end
end
table.insert(Event.Addon.SavedVariables.Save.Begin, {SpellSpamSave, "SpellSpam", "Save variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {SpellSpamLoad, "SpellSpam", "Load variables"})